{% extends 'kpi/base.html' %}
{% block title %}Распределение показателя{% endblock %}
{% block content %}
    <div class="content-basic">
        <div class="row">
            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-6" style="margin-top: -15px">
                <h3>Показатель: {{ indicator.context.name }}</h3>
                Набор: {{ indicator.set.set.name }}
            </div>
            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-6">
                <h4>Срок выполнения: {{ indicator.set.set.end_date|date:'d.m.Y' }}</h4>
                Осталось распределить: <span id="rest">{{ indicator.rest }}</span>
            </div>
        </div>
        <hr>
        <form id="form" method="POST">
            {% csrf_token %}
            <h3>Департаменты <a href="#" id="generate_dep">(добавить)</a> <a href="#" id="delete_dep">(удалить)</a></h3>
            <div id="departments" class="row">
                <div class="col-lg-6" id="dep_id_0">
                    <select name="dep_id_0" class="form-control">
                        <option selected disabled>Выберите департамент</option>
                        {% for department in indicator.set.department.children.all %}
                            <option value="{{ department.id }}">{{ department.name }}</option>
                        {% endfor %}
                    </select>
                </div>
                <div class="col-lg-6" id="dep_count_0">
                    <input type="number" name="dep_count_0" class="form-control" placeholder="Введите кол-во"/>
                    <br><br>
                </div>
            </div>
            <h3>Сотрудники <a href="#" id="generate_emp">(добавить)</a> <a href="#" id="delete_emp">(удалить)</a></h3>
            <div id="employees" class="row">
                <div class="col-lg-6" id="emp_id_0">
                    <select name="emp_id_0" class="form-control">
                        <option selected disabled>Выберите сотрудника</option>
                        {% for employee in indicator.set.department.employees.all %}
                            <option value="{{ employee.id }}">{{ employee.fio }}</option>
                        {% endfor %}
                    </select>
                </div>
                <div class="col-lg-6" id="emp_count_0">
                    <input type="number" name="emp_count_0" class="form-control" placeholder="Введите кол-во"/>
                    <br><br>
                </div>
            </div>
            <button type="submit" class="btn btn-primary">Распределить</button>
        </form>
    </div>
    <script>
        $(document).ready(function () {
            var i = 0;
            var j = 0;
            $("#generate_dep").click(function () {
                i++;
                var text = "<div class=\"col-lg-6\" id=\"dep_id_" + i + "\">\n" +
                    "                    <select name=\"dep_id_" + i + "\" class=\"form-control\">\n" +
                    "                            <option selected disabled>Выберите департамент</option>\n" +
                "                        {% for department in indicator.set.department.children.all %}\n"+
                    "                            <option value=\"{{ department.id }}\">{{ department.name }}</option>\n"
                    +
                    "                        {% endfor %}\n" +
                "                    </select>\n" +
                "                </div>\n" +
                "                <div class=\"col-lg-6\" id=\"dep_count_" + i + "\">\n" +
                "                    <input type=\"number\" name=\"dep_count_" + i + "\" class=\"form-control\" placeholder=\"Введите кол-во\"/>\n" +
                "                <br><br></div>";
                $("#departments").append(text);
            });
            $("#delete_dep").click(function () {
                if (i >= 0) {
                    var rest = $("#rest");
                    var count = $("#dep_count_" + i + " input");
                    if (count.val() != "") {
                        rest.html(parseInt(rest.html()) + parseInt(count.val()));
                    }
                    $("#dep_id_" + i).remove();
                    $("#dep_count_" + i).remove();
                    i--;
                }
            });
            $("#generate_emp").click(function () {
                j++;
                var text = "<div class=\"col-lg-6\" id=\"emp_id_" + j + "\">\n" +
                    "                    <select name=\"emp_id_" + j + "\" class=\"form-control\">\n" +
                "                            <option selected disabled>Выберите сотрудника</option>\n" +
                    "                        {% for employee in indicator.set.department.employees.all %}\n" +
                        "                            <option value=\"{{ employee.id }}\">{{ employee.fio }}</option>\n" +
                        "                        {% endfor %}\n" +
                    "                    </select>\n" +
                    "                </div>\n" +
                    "                <div class=\"col-lg-6\" id=\"emp_count_" + j + "\">\n" +
                    "                    <input type=\"number\" name=\"emp_count_" + j + "\" class=\"form-control\" placeholder=\"Введите кол-во\"/>\n" +
                    "                <br><br></div>\n";
                $("#employees").append(text);
            });
            $("#delete_emp").click(function () {
                if (j >= 0) {
                    var rest = $("#rest");
                    var count = $("#emp_count_" + j + " input");
                    if (count.val() != "") {
                        rest.html(parseInt(rest.html()) + parseInt(count.val()));
                    }
                    $("#emp_id_" + j).remove();
                    $("#emp_count_" + j).remove();
                    j--;
                }
            });
        });
        $(document).on('focusin', 'input', function () {
            console.log("Saving value " + $(this).val());
            $(this).data('val', $(this).val());
        }).on('change', 'input', function () {
            var rest = $("#rest");
            var previous = $(this).data('val');
            var current = $(this).val();
            console.log("Previous is " + previous);
            console.log("Current is " + current);
            if (previous == "") {
                console.log("first");
                rest.html(rest.html() - current);
            } else if (current == "") {
                console.log("second");
                rest.html(parseInt(rest.html()) + parseInt(previous));
            } else {
                console.log("third");
                rest.html(parseInt(rest.html()) + parseInt(previous) - current);
            }
        });
    </script>
{% endblock %}
